<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDealPendingApprovalDetails ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDealPendingApprovalDetails
 * @subpackage Arrays
 */
class ArrayOfDealPendingApprovalDetails extends AbstractStructArrayBase
{
    /**
     * The DealPendingApprovalDetails
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DealPendingApprovalDetails[]
     */
    public $DealPendingApprovalDetails;
    /**
     * Constructor method for ArrayOfDealPendingApprovalDetails
     * @uses ArrayOfDealPendingApprovalDetails::setDealPendingApprovalDetails()
     * @param \StructType\DealPendingApprovalDetails[] $dealPendingApprovalDetails
     */
    public function __construct(array $dealPendingApprovalDetails = array())
    {
        $this
            ->setDealPendingApprovalDetails($dealPendingApprovalDetails);
    }
    /**
     * Get DealPendingApprovalDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DealPendingApprovalDetails[]|null
     */
    public function getDealPendingApprovalDetails()
    {
        return isset($this->DealPendingApprovalDetails) ? $this->DealPendingApprovalDetails : null;
    }
    /**
     * Set DealPendingApprovalDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DealPendingApprovalDetails[] $dealPendingApprovalDetails
     * @return \ArrayType\ArrayOfDealPendingApprovalDetails
     */
    public function setDealPendingApprovalDetails(array $dealPendingApprovalDetails = array())
    {
        foreach ($dealPendingApprovalDetails as $arrayOfDealPendingApprovalDetailsDealPendingApprovalDetailsItem) {
            // validation for constraint: itemType
            if (!$arrayOfDealPendingApprovalDetailsDealPendingApprovalDetailsItem instanceof \StructType\DealPendingApprovalDetails) {
                throw new \InvalidArgumentException(sprintf('The DealPendingApprovalDetails property can only contain items of \StructType\DealPendingApprovalDetails, "%s" given', is_object($arrayOfDealPendingApprovalDetailsDealPendingApprovalDetailsItem) ? get_class($arrayOfDealPendingApprovalDetailsDealPendingApprovalDetailsItem) : gettype($arrayOfDealPendingApprovalDetailsDealPendingApprovalDetailsItem)), __LINE__);
            }
        }
        if (is_null($dealPendingApprovalDetails) || (is_array($dealPendingApprovalDetails) && empty($dealPendingApprovalDetails))) {
            unset($this->DealPendingApprovalDetails);
        } else {
            $this->DealPendingApprovalDetails = $dealPendingApprovalDetails;
        }
        return $this;
    }
    /**
     * Add item to DealPendingApprovalDetails value
     * @throws \InvalidArgumentException
     * @param \StructType\DealPendingApprovalDetails $item
     * @return \ArrayType\ArrayOfDealPendingApprovalDetails
     */
    public function addToDealPendingApprovalDetails(\StructType\DealPendingApprovalDetails $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DealPendingApprovalDetails) {
            throw new \InvalidArgumentException(sprintf('The DealPendingApprovalDetails property can only contain items of \StructType\DealPendingApprovalDetails, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DealPendingApprovalDetails[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DealPendingApprovalDetails|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DealPendingApprovalDetails|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DealPendingApprovalDetails|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DealPendingApprovalDetails|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DealPendingApprovalDetails|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DealPendingApprovalDetails
     */
    public function getAttributeName()
    {
        return 'DealPendingApprovalDetails';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDealPendingApprovalDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
