<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Submit ServiceType
 * @subpackage Services
 */
class Submit extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named SubmitDeal
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\SubmitDeal $parameters
     * @return \StructType\SubmitDealResponse|bool
     */
    public function SubmitDeal(\StructType\SubmitDeal $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->SubmitDeal($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named SubmitDeal_0_0_1
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\SubmitDeal_0_0_1 $parameters
     * @return \StructType\SubmitDeal_0_0_1Response|bool
     */
    public function SubmitDeal_0_0_1(\StructType\SubmitDeal_0_0_1 $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->SubmitDeal_0_0_1($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named SubmitIncomingDeal
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\SubmitIncomingDeal $parameters
     * @return \StructType\SubmitIncomingDealResponse|bool
     */
    public function SubmitIncomingDeal(\StructType\SubmitIncomingDeal $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->SubmitIncomingDeal($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\SubmitDealResponse|\StructType\SubmitDeal_0_0_1Response|\StructType\SubmitIncomingDealResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
